unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, QuickRpt, ExtCtrls, Mask, DBCtrls, QRCtrls, ComCtrls,
  DB, DBClient;

type
  tmpEdit = class(TDBEdit);

type
  TForm1 = class(TForm)
    QRCompositeReport1: TQRCompositeReport;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    QuickRep2: TQuickRep;
    QRBand2: TQRBand;
    QRLabel2: TQRLabel;
    QuickRep1: TQuickRep;
    QRBand1: TQRBand;
    QRBand3: TQRBand;
    QRBand4: TQRBand;
    QRLabel1: TQRLabel;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1id: TStringField;
    ClientDataSet1name: TStringField;
    ClientDataSet1department: TStringField;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRGroup1: TQRGroup;
    QRBand5: TQRBand;
    QRGroup2: TQRGroup;
    QRBand6: TQRBand;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRBand7: TQRBand;
    QRLabel5: TQRLabel;
    QRBand8: TQRBand;
    QRLabel6: TQRLabel;
    procedure Button1Click(Sender: TObject);
    procedure QRCompositeReport1AddReports(Sender: TObject);
    procedure QRGroup2BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
    P_CompositeReport : Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}




procedure TForm1.Button1Click(Sender: TObject);
var
  I : Integer;
begin
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  Randomize;
  for I := 1 to 100 do
    begin
      with ClientDataSet1 do
        begin
          Append;
          FieldByName('id').AsString := FormatFloat('00000',I);
          FieldByName('name').AsString := 'Name' + FormatFloat('00000',I);
          FieldByName('department').AsString := FormatFloat('00000',Random(10));
          Post;
        end;
    end;

    QRCompositeReport1.Reports.Clear;
    QRCompositeReport1.Prepare;
    QRCompositeReport1.Preview;
end;

procedure TForm1.QRCompositeReport1AddReports(Sender: TObject);
begin
    P_CompositeReport := False;
    with (Sender as TQRCompositeReport) do
        begin
            CASE RadioGroup1.ItemIndex OF
                0 : Reports.Add(QuickRep1);
                1 : Reports.Add(QuickRep2);
                2 : BEGIN
                        P_CompositeReport := True;
                        Reports.Add(QuickRep1);
                        Reports.Add(QuickRep2);
                    END;
                ELSE
                    NULL
            END;
        end;
end;

procedure TForm1.QRGroup2BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  if P_CompositeReport then
    begin
      TQRCustomBand(Sender).ForceNewPage := True;
      P_CompositeReport := False;
    end
  else
    TQRCustomBand(Sender).ForceNewPage := False;
end;

end.
